//
//  Model.m
//  Zip
//
//  Created by NYU User on 3/27/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Model.h"


//Called each time select finds a record.

static int foundRecord(void *p, int argc, char **argv, char **colName)
{
	NSMutableString *s = p;
	
	for (int i = 0; i < argc; ++i) {
		[s appendFormat: @"%s: %s\n", colName[i], argv[i]];
	}
	
	return SQLITE_OK;
}


@implementation Model

- (id) init {
	if ((self = [super init]) != nil) {
		NSBundle *bundle = [NSBundle mainBundle];
		NSString *fileName =
			[bundle pathForResource: @"zipcodes" ofType: @"db"];

		if (fileName == nil) {
			NSLog(@"Couldn't find path for resource.");
			[self release];
			return nil;
		}
		
		if (sqlite3_open([fileName UTF8String], &base) != SQLITE_OK) {
			NSLog(@"sqlite3_open: %s", sqlite3_errmsg(base));
			[self release];
			return nil;
		}
	}
	return self;
}

- (NSString *) getZip: (NSString *) zip {
	NSMutableString *s = [NSMutableString stringWithCapacity: 0];
	char *const sql = sqlite3_mprintf(
		"select * from zipcodes where zipcode = '%q';",
			[zip UTF8String]
	);
	
	if (sql == NULL) {
		NSLog(@"sqlite3_mprintf failed.");
		return s;
	}

	char *error;
	if (sqlite3_exec(base, sql, foundRecord, s, &error) != SQLITE_OK) {
		NSLog(@"%s", error);
		sqlite3_free(error);
	}
	
	sqlite3_free(sql);
	return s;
}

- (void) dealloc {
	if (sqlite3_close(base) != SQLITE_OK) {
		NSLog(@"sqlite3_close failed.");
	}
	[super dealloc];
}
@end
