//
//  View.m
//  Zip
//
//  Created by NYU User on 3/27/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ZipAppDelegate.h"
#import "Model.h"
#import "View.h"

@implementation View


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame]) != nil) {
		// Initialization code
		self.backgroundColor = [UIColor whiteColor];
		
		//Create the UITextField.
		
		UIFont *font = [UIFont fontWithName: @"Times New Roman" size: 24];
		CGRect b = self.bounds;
		CGRect f = CGRectMake(0, 0, b.size.width, 40);
		
		textField = [[UITextField alloc] initWithFrame: f];
		textField.backgroundColor = [UIColor yellowColor];
		textField.font = font;
		textField.keyboardType = UIKeyboardTypeNumbersAndPunctuation;
		textField.placeholder = @"<type a zipcode>";
		textField.delegate = self;
		[self addSubview: textField];
		
		//Create the UITextView.  Keyboard is 216 pixels high.
		
		CGFloat margin = 5;
		
		f = CGRectMake(
			0,
			textField.bounds.size.height + margin,
			b.size.width,
			b.size.height - textField.bounds.size.height - 2 * margin - 216
		);
		
		textView = [[UITextView alloc] initWithFrame: f];
		textView.backgroundColor = [UIColor orangeColor];
		textView.font = font;
		textView.editable = NO;
		textView.delegate = self;
		[self addSubview: textView];
	}
	return self;
}

//Called when return key is pressed.

- (BOOL) textFieldShouldReturn: (UITextField *) t {
	if (t == textField) {
		[t resignFirstResponder];	//Hide keyboard.
		return NO;	//The return button should not do its default behavior.
	}
	
	return YES;	//The return button should do its default behavior.
}

//Called when keyboard is hidden.

- (void) textFieldDidEndEditing: (UITextField *) t {
	if (t == textField) {
		ZipAppDelegate *d = [UIApplication sharedApplication].delegate;
		Model *model = d.model;
		textView.text = [model getZip: textField.text];

		if ([textView.text isEqualToString: @""]) {
			textView.text = [NSString stringWithFormat:
				@"could not find “%@”", textField.text];
		}
	}
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

- (void) dealloc {
	[textView release];
	[textField release];
	[super dealloc];
}

@end
